Skip to main content
POST
/
v1
/
playbooks
/
update
UpdatePlaybook
curl --request POST \
  --url https://app.textql.com/v1/playbooks/update \
  --header 'Authorization: Bearer <token>' \
  --header 'Connect-Protocol-Version: <connect-protocol-version>' \
  --header 'Content-Type: application/json' \
  --data '
{
  "playbookId": "<string>",
  "name": "<string>",
  "prompt": "<string>",
  "status": "STATUS_UNKNOWN",
  "triggerType": "TRIGGER_TYPE_UNKNOWN",
  "cronString": "<string>",
  "datasetIds": [
    "<string>"
  ],
  "connectorId": 123,
  "referenceReportId": "<string>",
  "paradigmOptions": {
    "basic": {}
  },
  "paradigmType": "TYPE_UNKNOWN",
  "emailAddresses": [
    "<string>"
  ],
  "slackChannelId": "<string>",
  "taggedSlackUserIds": [
    "<string>"
  ],
  "reportOutputStyle": "REPORT_STYLE_UNKNOWN",
  "templateHeaderId": "<string>",
  "selectedTemplateDataIds": [
    "<string>"
  ],
  "maxConcurrentTemplates": 2,
  "autoOptimizeConcurrency": true,
  "connectorIds": [
    123
  ],
  "llmModel": "MODEL_UNKNOWN"
}
'
{
  "playbook": {
    "id": "<string>",
    "orgId": "<string>",
    "memberId": "<string>",
    "connectorId": 123,
    "name": "<string>",
    "prompt": "<string>",
    "createdAt": "2023-11-07T05:31:56Z",
    "updatedAt": "2023-11-07T05:31:56Z",
    "status": "STATUS_UNKNOWN",
    "triggerType": "TRIGGER_TYPE_UNKNOWN",
    "cronString": "<string>",
    "datasetIds": [
      "<string>"
    ],
    "referenceReportId": "<string>",
    "latestChatId": "<string>",
    "emailAddresses": [
      "<string>"
    ],
    "slackChannelId": "<string>",
    "taggedSlackUserIds": [
      "<string>"
    ],
    "llmModel": "MODEL_UNKNOWN",
    "paradigmOptions": {
      "basic": {}
    },
    "paradigmType": "TYPE_UNKNOWN",
    "isRunning": true,
    "owner": {
      "memberId": "<string>",
      "memberEmail": "<string>",
      "memberName": "<string>",
      "memberPictureUrl": "<string>"
    },
    "hasWritePermission": true,
    "isSubscribed": true,
    "reportOutputStyle": "REPORT_STYLE_UNKNOWN",
    "templateHeaderId": "<string>",
    "selectedTemplateDataIds": [
      "<string>"
    ],
    "maxConcurrentTemplates": 123,
    "autoOptimizeConcurrency": true,
    "connectorIds": [
      123
    ],
    "templateDataFilters": [
      {
        "field": "<string>",
        "operator": "<string>",
        "value": "<string>"
      }
    ],
    "parentPlaybookId": "<string>",
    "originPlaybookId": "<string>",
    "duplicatedByMemberId": "<string>",
    "duplicatedAt": "2023-11-07T05:31:56Z",
    "chatAccessMode": "CHAT_ACCESS_MODE_INHERIT",
    "chatAccessOverrides": [
      {
        "memberId": "<string>",
        "roleId": "<string>",
        "accessType": "<string>"
      }
    ],
    "chatIsPublic": true,
    "dashboardIds": [
      "<string>"
    ]
  },
  "updatedFields": [
    "<string>"
  ],
  "updatedAt": "2023-11-07T05:31:56Z"
}

Authorizations

Authorization
string
header
required

Bearer authentication header of the form Bearer <token>, where <token> is your auth token.

Headers

Connect-Protocol-Version
enum<number>
required

Define the version of the Connect protocol

Available options:
1
Connect-Timeout-Ms
number

Define the timeout, in ms

Body

application/json
playbookId
string
Minimum string length: 1
name
string | null
prompt
string | null
status
enum<string> | null
Available options:
STATUS_UNKNOWN,
STATUS_ACTIVE,
STATUS_INACTIVE,
STATUS_EMPTY,
ALL_PLAYBOOKS
triggerType
enum<string> | null
Available options:
TRIGGER_TYPE_UNKNOWN,
TRIGGER_TYPE_CRON,
TRIGGER_TYPE_WEBHOOK
cronString
string | null
datasetIds
string[]
connectorId
integer<int32> | null
referenceReportId
string | null
paradigmOptions
paradigm_options · object
paradigmType
enum<string> | null
Available options:
TYPE_UNKNOWN,
TYPE_SQL,
TYPE_RESEARCH,
TYPE_ONTOLOGY,
TYPE_BASIC,
TYPE_TABLEAU,
TYPE_EXPERIMENTAL,
TYPE_UNIVERSAL,
TYPE_PUBLIC_DEMO
emailAddresses
string[]
slackChannelId
string | null
taggedSlackUserIds
string[]
reportOutputStyle
enum<string> | null
Available options:
REPORT_STYLE_UNKNOWN,
EXECUTIVE_REPORT,
VERBOSE,
CONCISE
templateHeaderId
string | null
selectedTemplateDataIds
string[]
maxConcurrentTemplates
integer<int32> | null
Required range: x >= 1
autoOptimizeConcurrency
boolean | null
connectorIds
integer<int32>[]
llmModel
enum<string> | null
Available options:
MODEL_UNKNOWN,
MODEL_DEFAULT_SMALL,
MODEL_DEFAULT,
MODEL_DEFAULT_LARGE,
MODEL_DEFAULT_REASONING,
MODEL_HAIKU_3,
MODEL_HAIKU_3_5,
MODEL_SONNET_3_5,
MODEL_SONNET_3_6,
MODEL_SONNET_3_7,
MODEL_SONNET_4,
MODEL_OPUS_4,
MODEL_SONNET_4_5,
MODEL_HAIKU_4_5,
MODEL_OPUS_4_5,
MODEL_OPUS_4_6,
MODEL_SONNET_4_6,
MODEL_GPT_4,
MODEL_GPT_4_TURBO,
MODEL_GPT_4O,
MODEL_GPT_4_1,
MODEL_GPT_4_1_MINI,
MODEL_GPT_4_1_NANO,
MODEL_O_1,
MODEL_O_1_MINI,
MODEL_O_3,
MODEL_O_3_MINI,
MODEL_O_4_MINI,
MODEL_GPT_5,
MODEL_GPT_5_MINI,
MODEL_GPT_5_NANO,
MODEL_GPT_5_2,
MODEL_GPT_5_2_PRO,
MODEL_GPT_5_4,
MODEL_GEMINI_3_FLASH,
MODEL_GEMINI_3_PRO,
MODEL_KIMI_K2_INSTRUCT,
MODEL_QWEN3_CODER,
MODEL_QWEN3_CODER_SMALL,
MODEL_GPT_OSS,
MODEL_GPT_OSS_SMALL,
MODEL_GLM_4_5,
MODEL_GLM_4_6,
MODEL_KIMI_K2_THINKING,
MODEL_KIMI_K2_5,
MODEL_DEEPSEEK_3_2,
MODEL_GLM_5

Response

Success

playbook
playbook · object
updatedFields
string[]
updatedAt
string<date-time>

A Timestamp represents a point in time independent of any time zone or local calendar, encoded as a count of seconds and fractions of seconds at nanosecond resolution. The count is relative to an epoch at UTC midnight on January 1, 1970, in the proleptic Gregorian calendar which extends the Gregorian calendar backwards to year one.

All minutes are 60 seconds long. Leap seconds are "smeared" so that no leap second table is needed for interpretation, using a 24-hour linear smear.

The range is from 0001-01-01T00:00:00Z to 9999-12-31T23:59:59.999999999Z. By restricting to that range, we ensure that we can convert to and from RFC 3339 date strings.

Examples

Example 1: Compute Timestamp from POSIX time().

Timestamp timestamp;
timestamp.set_seconds(time(NULL));
timestamp.set_nanos(0);

Example 2: Compute Timestamp from POSIX gettimeofday().

struct timeval tv;
gettimeofday(&tv, NULL);

Timestamp timestamp;
timestamp.set_seconds(tv.tv_sec);
timestamp.set_nanos(tv.tv_usec * 1000);

Example 3: Compute Timestamp from Win32 GetSystemTimeAsFileTime().

FILETIME ft;
GetSystemTimeAsFileTime(&ft);
UINT64 ticks = (((UINT64)ft.dwHighDateTime) << 32) | ft.dwLowDateTime;

// A Windows tick is 100 nanoseconds. Windows epoch 1601-01-01T00:00:00Z
// is 11644473600 seconds before Unix epoch 1970-01-01T00:00:00Z.
Timestamp timestamp;
timestamp.set_seconds((INT64) ((ticks / 10000000) - 11644473600LL));
timestamp.set_nanos((INT32) ((ticks % 10000000) * 100));

Example 4: Compute Timestamp from Java System.currentTimeMillis().

long millis = System.currentTimeMillis();

Timestamp timestamp = Timestamp.newBuilder().setSeconds(millis / 1000)
.setNanos((int) ((millis % 1000) * 1000000)).build();

Example 5: Compute Timestamp from Java Instant.now().

Instant now = Instant.now();

Timestamp timestamp =
Timestamp.newBuilder().setSeconds(now.getEpochSecond())
.setNanos(now.getNano()).build();

Example 6: Compute Timestamp from current time in Python.

timestamp = Timestamp()
timestamp.GetCurrentTime()

JSON Mapping

In JSON format, the Timestamp type is encoded as a string in the RFC 3339 format. That is, the format is "{year}-{month}-{day}T{hour}:{min}:{sec}[.{frac_sec}]Z" where {year} is always expressed using four digits while {month}, {day}, {hour}, {min}, and {sec} are zero-padded to two digits each. The fractional seconds, which can go up to 9 digits (i.e. up to 1 nanosecond resolution), are optional. The "Z" suffix indicates the timezone ("UTC"); the timezone is required. A proto3 JSON serializer should always use UTC (as indicated by "Z") when printing the Timestamp type and a proto3 JSON parser should be able to accept both UTC and other timezones (as indicated by an offset).

For example, "2017-01-15T01:30:15.01Z" encodes 15.01 seconds past 01:30 UTC on January 15, 2017.

In JavaScript, one can convert a Date object to this format using the standard toISOString() method. In Python, a standard datetime.datetime object can be converted to this format using strftime with the time format spec '%Y-%m-%dT%H:%M:%S.%fZ'. Likewise, in Java, one can use the Joda Time's ISODateTimeFormat.dateTime() to obtain a formatter capable of generating timestamps in this format.

Examples:

"2023-01-15T01:30:15.01Z"

"2024-12-25T12:00:00Z"